**Problem A. Key races**

**Problem B. The number on the board**

**Problem C. Star sky**

**Problem D. Palindromic characteristics**

**Problem E. The penguin's game**

**Problem F. Roads in the Kingdom**

Please subscribe to the official Codeforces channel in Telegram via the link https://t.me/codeforces_official.
×

# | User | Rating |
---|---|---|

1 | tourist | 3707 |

2 | Benq | 3672 |

3 | Radewoosh | 3655 |

4 | ksun48 | 3547 |

5 | jiangly | 3492 |

6 | Miracle03 | 3480 |

7 | ecnerwala | 3400 |

8 | maroonrk | 3385 |

9 | peehs_moorhsum | 3384 |

10 | sunset | 3338 |

# | User | Contrib. |
---|---|---|

1 | 1-gon | 214 |

2 | Um_nik | 190 |

3 | sus | 183 |

4 | YouKn0wWho | 181 |

4 | awoo | 181 |

6 | Errichto | 179 |

7 | tourist | 178 |

8 | -is-this-fft- | 172 |

9 | Radewoosh | 170 |

10 | Ashishgup | 169 |

Tutorial of Codeforces Round #427 (Div. 2)

↑

↓

Codeforces (c) Copyright 2010-2021 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Sep/21/2021 11:12:44 (h1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|

I did a O(nclogX + QlogX) solution for problem C. Where X is the maximum coordinate. Answering each query in O(log X).

del

For problem C ,what I am doing is storing the cummlative sum of the value of all stars in a row x upto y at time instant t as cum[x][y][t] for all t<=10 and then for each query I am running a loop for i= x1 to x2 and adding cum[i][y2][t]-cum[i][y1-1][t] to the answer where t=t mod (c+1) .I am getting WA.Can anyone please help? code link : http://codeforces.com/contest/835/submission/29068753

two stars may have the same x,y

Oh i totally missed that! Thank you!

Hi! In

problem CI tried to do a Brute force solution with some optimization but getting WA for TEST 3. Can someone please look at my code. http://codeforces.com/contest/835/submission/29078375You must have ignored the possibility of having two or more star at one point.

See carefully constraint for number of stars (10^5) is more than the grid (100*100)

Yeah...Thanks a lot! that was the issue and changing lower_bound to upper_bound for r1 calculation solved the issue. Earlier I thought that no 2 stars can be at a single point (despite of seeing the constraints). But since the sky is 3-D a person will see 2 stars which are separated by vertical distance on top of each other at a same point.

Does this mean that the right half of

`abba`

is actually`ab`

not`ba`

? I was solving it as if the right half was`ba`

.It is

`ba`

.I had a huge thing misunderstood during the contest, thanks for clarifying.

So the condition was supposed to be "the left half is the reverse of the right half"? or am I understanding something wrong?

I don't think you're right. In the statement: "Its left half equals to its right half", and this is the tricky part.

No, it wasn't. But we can prove that it is.

Let's prove that k-palindrome (k >= 1) is palindrome. k = 1 is by definition. k >= 2: s = t + c + t, where t is (k — 1)-palindrome and c is some character or empty string. s is k-palindrome. So, t is (k — 1) palindrome. And we know that t is palindrome. So, reversed(t) = t. And s = t + c + reversed(t) and it is palindrome.

It is proof by induction.

Why is dp[l][r]=dp[l][m]+1?

Yeah the editorials for even other contests should be posted fast like this one! :)

Sorry for my poor English:) Can anyone explain problem B, forth test, i tried to think on it but my answer is also wrong, help me!!!

UPD: I FINNALY UNDERSTOOD MY MISTAKE :DHello!For problem C.I looked through questions of contestants and my question is quite similar to those. I just can't understand why i got WA on 3 Test. I took into account case, when stars are in one spot, but it didn't help me. It will great help to me if someone will find bug in my code: http://codeforces.com/contest/835/submission/29064634

It will be great help*

For problem C, what I did was storing the brightness of stars in the array and accumulating the (brightness + t) % (maxBrightness+1) inside a given rectangle. Suppose maximum brightness is 4 and the query is (1,1,1,2,2).

The brightness of stars are stored in a following manner:

0 0 0 0

0 1 2 0

0 0 0 0

I am checking from (1,1) to (2,2) and and it produces: (1+a[1][1]) % 4 + (1+ a[2][1]) % 4 = 3 What seems to be a prolbem?

I would appreciate if someone point out the logical defect on the idea. http://codeforces.com/contest/835/submission/29073973

There can be multiple stars at a point. Also, it seems that you are looping through the rectangle of each view, which might be too many operations to fit in the time limit.

Hey, __ea, if you don't mind, can you please have a look at my code for problem C. It got TLE on test 8. This is my code

In D we should make m = [(l+r)/2]-1 only if length of substring is odd, otherwise m= [(l+r)/2]; By the way, how to use special symbols? like [ ]?

Can someone explain what is bad with input/output in my solution of E?29084972

You need to flush the output every time you print. Some languages back up all printing operations into a buffer until there's enough (because printing takes time, so printing a single large string is faster than many small strings). This makes the grader to not be able to see your output; flushing forces the language to actually print it out to the output no matter whether the buffer is full or not. It's also written in the problem statement.

Nope, it doesnt help (in java println workes like flust). I tried to use flush after every print and only after printlns, nothing helps. I dont get where is mb mistake...

Proof that 19 questions is necessary for E:

At the worst case,

n= 1000, so there are possible answers. You need to find the single correct answer. Each question you ask will give 2 possibilities, sokquestions will give 2^{k}possibilities. Of course, you need 2^{k}≥ 499500, otherwise some answers to the questions will have lump multiple possibilities together. Thusk≥ 19.For Problem D, I found a simple solution using Palindromic Tree, which runs in

O(|s|) time and uses onlyO(|s|) memory.29085544In fact I found this problem quite similar to another Codechef problem Here, but in this problem the range of |

s| is much smaller.Actually i got AC only when i saw your comment and checked the explanation of the samples over there so thank you.

Do you mind explaining your panlindromic tree solution?

It's hard to explain the whole idea of palindromic tree here, this tutorial may be useful.

First let's define the palindromeness of a palindrome

Sas the maximumkthatSis k-palindrome. In this problem, actually we need to calculate the palindromeness and the number of occurrences for each palindrome.The second problem is a basic application of palindromic tree which can be found in the blog above. To deal with the second one, for each palindrome

Swe need to know the longest palindrome prefixPwhose length doesn't exceed , the palindromeness ofSequals to the palindromeness ofP+ 1 if . It equals to 1 otherwise.So the only remaining problem is to find

Pfor each palindrome. And it's easy to cope with that with similar method of calculating the longest prefix palindrome. You can take a look at my code (wherehalf[S] presentsP) for more details.Sorry for my poor English, hope you can get what I mean.

Thanks for your kind advice. I managed to understand your explanation and implement the AC solution. I learnt a lot from this!

Once again, thanks so much for your help!

I know my code for D is not very efficient, but after testing 5000 'a's in custom test and it runs under 2800ms, I decided to submit it. But it gets TLE on test 30. However I submitted the exact same code after contest it passed. Does anyone knows the reason? Thanks.

Code in contest: 29067565 Code after contest: 29086375

You could write to jury. May be technique dependence.

Excuse me, what wrong or impolite did I say?

I don't know, but 400ms difference on the same test case with the same code seems significant.

Here is a trap in Problem C: There maybe two stars with the same pos! I got WA for many times because of this!

its kinda obvious that there are . since there can be 1e5 stars but there are a maximum of 100 * 100 positions possible for them

OK.I'm sorry. Maybe I'm too weak

haha I wasted 2 hs because of that detail

im sorry i didnt mean that

I was wondering if problem C could be done using convex hull? Can somebody please explain why not and if yes then how.

Your queries are rectangles so it doesn't make any sense to use convex hull.

Looking For recursive solution For Problem D..

my code

Finally done by recursive implementation...check For reference

For problem D, would anyone like to prove OBS1? i know it's kind of obvious but i still wonder why :L

I explained it this way: divide our palindrome into 2 halves, while they are identical, i.e. abacaba <- aba <- a. Length of this chain is k, every member in it can be represented as 1-palindrome, so our initial string can be [1..k]-palindrome. (if we assign aba as 1-palindrome, abacaba would be 2-palindrome, if we assign a as 1-palindrome, abacaba would be 3-palindrome)

By induction, just assume that for any n <= k, n-palindrome is a 1-palindrome, then prove it for n = k + 1. So, let's take (k + 1)-palindrome, left and right halves of it must be same k-palindromes, which are 1-palindromes by our inductive assumption, thus the whole (k + 1)-palindrome is also 1-palindrome.

but whole

k+ 1 palindrome is also 1 palindrome doesn't provekpalindrome isk- 1 straightforwardly,right?Oh, sorry, I incorrectly understood OBS1, my bad:)

Ok then, just change the assumption, now by the assumption for any 1 < n <= k n-palindrome is (n — 1)-palindrome, too. The prove will be the same, the only thing to deal with is the base case for k = 2.

We can prove by induction on k

Theorem:if s is k-palindrome, s is also (k — 1) palindrome, k > 1, |s| > 1.Case |s| = 1, it's 1-palindrome = palindrome, since there's no definition of a 0-palindrome, there's nothing to prove.

Base case for induction:k = 2.If s is 2-palindrome, s can be written as

s' + c + s', s' is 1-palindrome, c is some character, possibly the empty character. Since s' is palindrome, s' + c + s' is also a palindrome, so every string which is 2-palindrome is also a 1-palindrome.Induction hypothesis:Every string s which is k-palindrome is also (k — 1) palindrome, |s| > 1, |k| > 2. The hypothesis is recursive until k = 2.s is k-palindrome so it can be written as

[k — 1] + c + [k — 1], where [x] denotes some string which is x-palindrome.Induction step:Let t be a (k + 1)-palindrome string.t = [k] + c + [k], c is some character, possibly the empty character (check above the meaning of the [k] notation). Our induction hypothesis says that a string [k] is also (k — 1)-palindrome, so we can replace [k] by [k — 1], so:t = [k] + c + [k]

t = [k — 1] + c + [k — 1]

A string is k-palindrome if can be written as [k — 1] + c + [k — 1], we just wrote t as this way so t is k-palindrome and the induction is finished.

I did not understand the equation cnt[p][x][y] = cnt[p][x - 1][y] + cnt[p][x][y - 1] - cnt[p][x - 1][y - 1] can someone please explain it to me.

cnt[p][x][y] = cnt[p][x - 1][y] + cnt[p][x][y - 1] - cnt[p][x - 1][y - 1]is not true, you have to add it up so=should be replaced with+=.cnt[p][x][y] += cnt[p][x - 1][y] + cnt[p][x][y - 1] - cnt[p][x - 1][y - 1]this is used to calculate the number of stars with brightness levelpat(x,y)position by known number of stars for previous positions at the same brightness level. To make it more clear we are subtractingcnt[p][x-1][y-1]because otherwise for any positionx,ynumbers of stars will be repeated, which is exactly we don't want :)Problem: C. Star sky. Can any one help me? I'm try too much time but problem statement isn't clear to me. Can anyone explain first or second testcase?

In Problem D,I thought of the solution above. However, I am afraid of the time limit because dp costs O(|s|^2) time and we must compare the string to make sure it's a palindrome, so I think the time is more than O(|s|^2), is this true?

After understanding the solution c++ code,I understand. Just ignore,please. I can use the result before to decrease much time complexity.

I do not understand the description of problem D clearly.

how is the answer for 2nd sample test case calculated?

`abacaba`

=>`12 4 1 0 0 0 0`

thanks in advance :)

If a string is K-palindromic it will be (K-1)-palindromic as well. That means that for a[1] = 12 we count every possible palindromic string. You can check that there are exist 12 palindromic strings. a[3] = 1 because only abacaba is 3-palindromic string. a[2] = 4, because {aba, aca, aba(2nd time)} are palindromic string but don't forget to add {abacaba} as well because it is 3-palindromic so it is 2-palindromic too. So a simple solution is to find the a[i] table and after do that operation a[i-1] += a[i].

How bacab got included in a[1]? Is bacab is not 2 palindrome?

Problem E

Really interested to know how to prove such a lower bound! :D

You can read the proof here: http://codeforces.com/blog/entry/53588?#comment-376471

Are there any binary search approach with DP to count the number of palindromic substring in a string. If yes please do provide me the code.

In problem D, why hashing TLE? I think the complexity of my solution is O(n^2 * log(n)) which is very small (correct me if I'm wrong) .

My submission: http://codeforces.com/contest/835/submission/29868893

Can anyone help me?

Hashes are slow. The constant factor of your solution is too large.

The intended solution is

O(n^{2}) and you don't need hashing in it.Ok thanks!

How can I solve D using hashing please help.

Can anyone please see my code for problem C? I am getting TLE on test 8. This is my code Please help me.

your code complexity is n*q which will exceed time limit

For Problem -C, What I am doing is that

I am using binary Searchto find the lower bound of (x1,y1) and similarly for (x2,y2). And applying the formulae for the stars in this range!.I am** getting WA on test case 3** but everything is correct. I guess!

On the 3rd output,there is adifference of 1 in my and tester solution.Can someone spot the problem? 78766033can anyone see why my solution for problem D is coming out wrong I tried using rolling hash two vectors one having forward hash A0(P^n-1) + A1*(P^n-2)......An-1 and backward hash An-1*(P^n-1)........A0

and then for all length in powers of 2 from 1 to 2^(logn) found no of palindromes and then calulated the prefix sum accordingly https://ideone.com/FaOlfO plz check my solution